This is an extension and not part of the main GoJS library. Note that the API for this class may change at any time. If you intend to use an extension in production, you should copy the code to your own source directory. Extensions can be found in the GoJS kit under the `extensions` or `extensionsTS` folders. See the Extensions intro page for more information.

### Hierarchy

- Layout
  - TreeLayout
    - ParallelLayout

A custom TreeLayout that can be used for laying out stylized flowcharts. Each layout requires a single "Split" node and a single "Merge" node. The "Split" node should be the root of a tree-like structure if one excludes links to the "Merge" node. This will position the "Merge" node to line up with the "Split" node.

You can set all of the TreeLayout properties that you like, except that for simplicity this code just works for angle === 0 or angle === 90.

If you want to experiment with this extension, try the Parallel Layout sample.

## Index

### Constructors

- constructor

### Properties

- mergeNode
- splitNode

### Methods

- findSplitMerge
- isConditional
- isMerge
- isSplit
- isSwitch

## Constructors

### constructor

- new ParallelLayout(): ParallelLayout

- Constructs a ParallelLayout and sets the following properties:

  - isRealtime = false
  - alignment = TreeLayout.AlignmentCenterChildren
  - compaction = TreeLayout.CompactionNone
  - alternateAlignment = TreeLayout.AlignmentCenterChildren
  - alternateCompaction = TreeLayout.CompactionNone

  #### Returns ParallelLayout

## Properties

### mergeNode : Node | null

- This read-only property returns the node that the tree will converge at.

### splitNode : Node | null

- This read-only property returns the node that the tree will extend from.

## Methods

### findSplitMerge

- findSplitMerge(vertexes: Iterable<TreeVertex>): void

- Return an Array holding the Split node and the Merge node for this layout. This signals an error if there is not exactly one Node that isSplit and exactly one Node that isMerge. This can be overridden; any override must set splitNode and mergeNode.

  #### Parameters

  - ##### vertexes: Iterable<TreeVertex>

  #### Returns void

### isConditional

- isConditional(node: Node | null): boolean

- Overridable predicate for deciding if a Node is a conditional or "If" type of Split Node expecting to have two links coming out of the sides.

  #### Parameters

  - ##### node: Node | null

  #### Returns boolean

### isMerge

- isMerge(node: Node | null): boolean

- Overridable predicate for deciding if a Node is a Merge node. By default this checks the node's Part.category to see if it is "Merge", "End", "EndFor", "EndWhile", "EndIf", or "EndSwitch".

  #### Parameters

  - ##### node: Node | null

  #### Returns boolean

### isSplit

- isSplit(node: Node | null): boolean

- Overridable predicate for deciding if a Node is a Split node. By default this checks the node's Part.category to see if it is "Split", "Start", "For", "While", "If", or "Switch".

  #### Parameters

  - ##### node: Node | null

  #### Returns boolean

### isSwitch

- isSwitch(node: Node | null): boolean

- Overridable predicate for deciding if a Node is a "Switch" type of Split Node expecting to have three links coming out of the bottom/right side.

  #### Parameters

  - ##### node: Node | null

  #### Returns boolean

Copyright © 1998-2020 by Northwoods Software Corporation.